
package com.example.civilizedcity.common;
import com.alibaba.fastjson.JSONObject;
import lombok.Data;
import lombok.experimental.Accessors;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Slf4j
@Component

public class SMSUtils implements InitializingBean {
    @Autowired
    HttpUtils httpUtils;
    @Value("${yz.sms.api}")
    String smsAPI;

    @Value("${yz.sms.appid}")
    String appid;

    public void sendMessage(Message message) throws Exception {
        long nowMills = System.currentTimeMillis();
        String timestamp = String.valueOf(nowMills);
        String secret = appid + timestamp;

        Map<String, String> header = new HashMap<>();
        header.put("x-appid", appid);
        header.put("x-timestamp", timestamp);
        header.put("x-sign", EncryptUtils.md5(appid + secret, timestamp));

        Map<String, String> body = new HashMap<>();
        body.put("PhoneNumbers", message.getTel());
        body.put("SignName", message.getSign());
        body.put("TemplateCode", message.getCode());
        body.put("TemplateParam", message.getContent());

        httpUtils.post(smsAPI, header, JSONObject.toJSONString(body, false));

    }

    @Override
    public void afterPropertiesSet() throws Exception {
    }

    @Data
    @Accessors(chain = true)
    public static class Message {
        String code;
        String tel;
        String sign;
        String content;
    }

}

//import com.alibaba.fastjson.JSONObject;
//import com.aliyuncs.CommonRequest;
//import com.aliyuncs.CommonResponse;
//import com.aliyuncs.DefaultAcsClient;
//import com.aliyuncs.IAcsClient;
//import com.aliyuncs.exceptions.ClientException;
//import com.aliyuncs.http.MethodType;
//import com.aliyuncs.profile.DefaultProfile;
//import org.springframework.stereotype.Service;
//
//import java.util.Map;

//@Service
////@EnableScheduling //开启定时任务
////@EnableAsync  //开启多线程
//public class SMSUtils {
//    //    @Override
////    @Async
////    @Scheduled(cron = "0 30 8 * * ?") //时隔多少秒
//    public static void smsMessage(String phoneNumber, String TemplateCode, Map code) {  //AccessKey ID 账号 AccessKey secret密码
//        DefaultProfile profile = DefaultProfile.getProfile("cn-nanjing", "LTAI4G16F251gw8zRaePUPQo", "你自己的密码");
//        IAcsClient client = new DefaultAcsClient(profile);
//        //阿里云原有的配置信息我们不需要改动
//        CommonRequest request = new CommonRequest();
//        request.setSysMethod(MethodType.POST);
//        request.setSysDomain("dysmsapi.aliyuncs.com");
//        request.setSysVersion("2017-05-25");
//        request.setSysAction("SendSms");
//        //自定义短信信息
//        request.putQueryParameter("phoneNumber", phoneNumber); //发送给哪个手机号
//        request.putQueryParameter("SignName", "清峰小栈");  //自己配置的短信签名
//        request.putQueryParameter("TemplateCode", TemplateCode); //自己配置的模板 模版CODE
//
//        //构建一个短信验证码
////        HashMap<String, Object> map = new HashMap<>();
////        map.put("code", 8456);
//        request.putQueryParameter("TemplateParam", JSONObject.toJSONString(code));   //转换成json字符串
//        try {
//            CommonResponse response = client.getCommonResponse(request); //发送至客户端
//            System.out.println(response.getData());
//        } catch (ClientException e) {
//            e.printStackTrace();
//        }
//    }
//
//}